﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _914510
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();

            radListView2.AllowDragDrop = true;
            radListView2.ViewType = ListViewType.IconsView;
            radListView2.VisualItemFormatting += radListView2_VisualItemFormatting;

            Image img = Image.FromFile(@"C:\img\delete.png");
            BindingList<MyIamgeObject> data = new BindingList<MyIamgeObject>();
            for (int i = 0; i < 10; i++)
            {
                data.Add(new MyIamgeObject(img, @"C:\img\delete.png"));
            }
            radListView1.ViewType = Telerik.WinControls.UI.ListViewType.IconsView;
            radListView1.ItemDataBound += radListView1_ItemDataBound;
          
            radListView1.DataSource = data;
            radListView1.VisualItemFormatting += radListView1_VisualItemFormatting;

            radListView1.AllowDragDrop = true;
            radListView1.ListViewElement.DragDropService.PreviewDragOver += DragDropService_PreviewDragOver;
            radListView1.ListViewElement.DragDropService.PreviewDragDrop += DragDropService_PreviewDragDrop;
        }

        void DragDropService_PreviewDragDrop(object sender, Telerik.WinControls.RadDropEventArgs e)
        {
            BaseListViewVisualItem draggedItem = e.DragInstance as BaseListViewVisualItem;
            
            var data = draggedItem.Data.DataBoundItem as MyIamgeObject;
            var item = new ListViewDataItem();

            radListView2.Items.Add(item);
            
            item.Image = data.Img;
            item.Tag = data.ImgPath;
        }

        void DragDropService_PreviewDragOver(object sender, Telerik.WinControls.RadDragOverEventArgs e)
        {
            e.CanDrop = e.HitTarget is IconListViewElement;
        }

        void radListView2_VisualItemFormatting(object sender, ListViewVisualItemEventArgs e)
        {
            e.VisualItem.DrawText = false;
            e.VisualItem.ImageAlignment = ContentAlignment.MiddleCenter;
        }

        void radListView1_VisualItemFormatting(object sender, Telerik.WinControls.UI.ListViewVisualItemEventArgs e)
        {
            e.VisualItem.DrawText = false;
            e.VisualItem.ImageAlignment = ContentAlignment.MiddleCenter;
        }

        void radListView1_ItemDataBound(object sender, Telerik.WinControls.UI.ListViewItemEventArgs e)
        {
            var databoundItem = e.Item.DataBoundItem as MyIamgeObject;
         
            e.Item.Image = databoundItem.Img;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            foreach (var item in radListView2.Items)
            {
                Console.WriteLine(item.Tag);
            }
        }
    }

    class MyIamgeObject
    {
        public Image Img { get; set; }

        public string ImgPath { get; set; }

        public MyIamgeObject(Image img, string imgPath)
        {
            this.Img = img;
            this.ImgPath = imgPath;
        }
    }
}